blob: 0a0d677ce452f332d39c32443bb81e15ec15b8fa [file] [log] [blame]
Don Newton98fd8812019-09-23 15:15:02 -04001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
17# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
Kent Hagerman6379e092020-02-18 18:05:57 -050021VERSION ?= $(shell cat ./VERSION)
Don Newton98fd8812019-09-23 15:15:02 -040022
23DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
27## Docker related
Kent Hagerman6379e092020-02-18 18:05:57 -050028DOCKER_EXTRA_ARGS ?=
29DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
31DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
Zack Williamsa054c7f2020-03-23 10:19:29 -070032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-ofagent-go
Don Newton98fd8812019-09-23 15:15:02 -040033
34## Docker labels. Only set ref and commit date if committed
35DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
36DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
37DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
38DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
39
40DOCKER_BUILD_ARGS ?= \
41 ${DOCKER_EXTRA_ARGS} \
42 --build-arg org_label_schema_version="${VERSION}" \
43 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
44 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
45 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
46 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
47 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
48
49DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \
50 --build-arg LOCAL_PROTOS=${LOCAL_PROTOS}
51
Kent Hagerman6379e092020-02-18 18:05:57 -050052# tool containers
Kent Hagerman3243ee52020-02-26 12:11:55 -050053VOLTHA_TOOLS_VERSION ?= 2.0.0
Kent Hagerman6379e092020-02-18 18:05:57 -050054
55GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
56GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
57GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman6379e092020-02-18 18:05:57 -050058GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
59HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
60
Don Newton98fd8812019-09-23 15:15:02 -040061.PHONY: docker-build local-protos local-voltha
62
63# This should to be the first and default target in this Makefile
64help:
65 @echo "Usage: make [<target>]"
66 @echo "where available targets are:"
67 @echo
68 @echo "docker-build : Build ofagent-go docker image"
69 @echo "help : Print this help"
70 @echo "docker-push : Push the docker images to an external repository"
71 @echo "lint : Run lint verification, depenancy, gofmt and reference check"
72 @echo "sca : Runs various SCA through golangci-lint tool"
73 @echo "test : Run unit tests, if any"
74 @echo
75
76
77## Local Development Helpers
78
79local-protos:
80ifdef LOCAL_PROTOS
81 mkdir -p vendor/github.com/opencord/voltha-protos/go
82 cp -r ${GOPATH}/src/github.com/opencord/voltha-protos/go/* vendor/github.com/opencord/voltha-protos/go
83endif
84
85local-voltha:
86ifdef LOCAL_VOLTHA
87 mkdir -p vendor/github.com/opencord/voltha-go/
88 cp -rf ${GOPATH}/src/github.com/opencord/voltha-go/ vendor/github.com/opencord/
89 rm -rf vendor/github.com/opencord/voltha-go/vendor
90endif
91
92
93## Docker targets
94
95docker-build: local-protos local-voltha
Kent Hagerman6379e092020-02-18 18:05:57 -050096 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME}:${DOCKER_TAG} -t ${ADAPTER_IMAGENAME}:latest -f docker/Dockerfile.ofagent-go .
Don Newton98fd8812019-09-23 15:15:02 -040097
98docker-push:
Kent Hagerman6379e092020-02-18 18:05:57 -050099 docker push ${ADAPTER_IMAGENAME}:${DOCKER_TAG}
Don Newton98fd8812019-09-23 15:15:02 -0400100
101## lint and unit tests
102
Kent Hagerman6379e092020-02-18 18:05:57 -0500103lint-dockerfile:
104 @echo "Running Dockerfile lint check..."
105 @${HADOLINT} $$(find . -name "Dockerfile.*")
106 @echo "Dockerfile lint check OK"
107
Don Newtone0d34a82019-11-14 10:58:06 -0500108lint-mod:
Don Newton98fd8812019-09-23 15:15:02 -0400109 @echo "Running dependency check..."
Kent Hagerman6379e092020-02-18 18:05:57 -0500110 @${GO} mod verify
111 @echo "Dependency check OK. Running vendor check..."
112 @git status > /dev/null
Kent Hagerman3243ee52020-02-26 12:11:55 -0500113 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
114 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman6379e092020-02-18 18:05:57 -0500115 ${GO} mod tidy
116 ${GO} mod vendor
117 @git status > /dev/null
Kent Hagerman3243ee52020-02-26 12:11:55 -0500118 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
119 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Kent Hagerman6379e092020-02-18 18:05:57 -0500120 @echo "Vendor check OK."
Don Newton98fd8812019-09-23 15:15:02 -0400121
Kent Hagerman3243ee52020-02-26 12:11:55 -0500122lint: lint-mod lint-dockerfile
Don Newton98fd8812019-09-23 15:15:02 -0400123
Don Newton98fd8812019-09-23 15:15:02 -0400124test:
Don Newton98fd8812019-09-23 15:15:02 -0400125 @mkdir -p ./tests/results
Kent Hagerman6379e092020-02-18 18:05:57 -0500126 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Don Newton98fd8812019-09-23 15:15:02 -0400127 RETURN=$$? ;\
Kent Hagerman6379e092020-02-18 18:05:57 -0500128 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
129 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Don Newton98fd8812019-09-23 15:15:02 -0400130 exit $$RETURN
131
Don Newton98fd8812019-09-23 15:15:02 -0400132sca:
Kent Hagerman6379e092020-02-18 18:05:57 -0500133 @rm -rf ./sca-report
Don Newton98fd8812019-09-23 15:15:02 -0400134 @mkdir -p ./sca-report
Kent Hagerman6379e092020-02-18 18:05:57 -0500135 @echo "Running static code analysis..."
136 @${GOLANGCI_LINT} run --deadline=4m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
137 @echo ""
138 @echo "Static code analysis OK"
Don Newton98fd8812019-09-23 15:15:02 -0400139
140clean:
Kent Hagerman6379e092020-02-18 18:05:57 -0500141 rm -rf ./sca-report
Don Newton98fd8812019-09-23 15:15:02 -0400142
143distclean: clean
144 rm -rf ${VENVDIR}
145
Kent Hagerman6379e092020-02-18 18:05:57 -0500146mod-update:
147 ${GO} mod tidy
148 ${GO} mod vendor